#include <iostream>

using namespace std;

int main()
{
    
    int a;
    cin >> a;
    int niz[200000];
    for (int i = 0; i < a; i++)
    {
        cin >> niz[i];
    }
    //int niz[] = { 1 ,7 ,2 ,7 ,2 ,2 ,3 };
    int b;
    cin >> b;
    for (int i = 0; i < b; i++)
    {
        int n;
        int m;
        int ind;
        bool jeste = true;
        bool p2 = false;
        bool ispucao = false;
        cin >> n >> m;
        for (int i = n - 1; i < m-1; i++)
        {
            if ((niz[i] > niz[i+1]) && ispucao) {
                //cout << niz[i] << " " << niz[i + 1];
                jeste = false;
                break;
            }
            if ((niz[i] > niz[i + 1]) && !ispucao) {
                //cout << niz[i] << " " << niz[i + 1];
                ind = i;
                ispucao = true;
            }
        }
        if ((ispucao && !jeste) && niz[ind] <= niz[ind + 2]) {
            p2 = true;
        }
        if (p2)
            for (int i = ind + 2; i < m-1; i++)
            {
                if ((niz[i] > niz[i+1]) && ispucao) {
                    //cout << niz[i] << " " << niz[i + 1];
                    jeste = false;
                    break;
                }
            }
        if (jeste)
            cout << "DA"<<endl;
        else
            cout << "NE" << endl;
    }
}